# $Source: /cvsroot/civ4ccp/civ4ccp/Assets/Python/CUSTOM/DEMO/Attic/DEMO_ActionButton.py,v $: $Name: dev $
#
#	DEMO Example for SimCutie's ActionButton facility.
#	See "ActionButton.py" for detailed information.
#
__author__ = "$Author: simcutie $"
__revision__ = "$Id: DEMO_ActionButton.py,v 1.1.4.4 2006/06/16 00:42:02 simcutie Exp $"
__version__ = "$Revision: 1.1.4.4 $"
__date__ = "$Date: 2006/06/16 00:42:02 $"

from CvPythonExtensions import *
import CvUtil
import time

gc = CvUtil.gc

import ActionButton

Act_Test1 = None
Act_Test2 = None

def EventHandlerRegister(evt_mgr, unused = None):
	"Register two action button event handler"
	import CvCustomEvent

	CvUtil.pyPrint( __name__ + ": Test Action Button Register OK" )
	return { CvCustomEvent.EVENT_BUTTONSHOW : onShowButtons, 
		CvCustomEvent.EVENT_BUTTONACTION : onActionButtons }

def helpFunc_Test2(args):
	"help generator for test2, updated on each mouse over"
	actID, data2, option = args[:3]
	return " Actid = %d, iData = %d\ntime= %s" % ( actID, data2, time.ctime())
	
def onShowButtons(argsList):
	""" called when Bottum Button List are updated"
	" argsList = ( selType, pSelectedUnit or pSelectedCity)"""
	global Act_Test1, Act_Test2
	bUnitSelection, pSelectedEntity = argsList[:2]

	if not Act_Test1 or not Act_Test2 :
		# init action buttons
		Act_Test1 = ActionButton.createButton("PYACTION_TEST1")
		btn = gc.getCivilizationInfo( gc.getInfoTypeForString("CIVILIZATION_AMERICA" )).getButton()
		Act_Test1.setButton(btn)
		Act_Test1.setHelp( "TXT_KEY_DEMO_ACTION_BUTTON_TEST1_HELP" )

		Act_Test2 = ActionButton.createButton("PYACTION_TEST2" )
		Act_Test2.setButton("CIVIC_HEREDITARY_RULE" )
		Act_Test2.setHelp(helpFunc_Test2)

	if bUnitSelection :
		Act_Test1.showButton()
	else:
		Act_Test2.setHandlerData( strData=("Test 2 Button SELECTED\n at " + time.ctime())  )
		Act_Test2.showButton( iData=1234)


def onActionButtons( argsList):
	" called when an action button is pressed. You must check actId (argsList[0])."
	global Act_Test1, Act_Test2
	( actId, bUnitSelection, pSelectedEntity, bRightClick, iData, strData ) = argsList[:6]

	if actId == Act_Test1.getID() :
		CyInterface().addImmediateMessage( "BUTTON TEST1", "")
		#PyCivSim.MSGDEBUG( "BUTTON TEST1")
	elif actId == Act_Test2.getID() :
		CyInterface().addImmediateMessage( strData, "")
	else :
		return False
	return True
