# $Source: /cvsroot/civ4ccp/civ4ccp/Assets/Python/CUSTOM/DEMO/Attic/DEMO_MoreCityName.py,v $: $Name: dev $
#	Random City Name Generator By SimCutie
#	$CopyRight$
#	by SimCutie < simcutie (AT) hanmail.net >
#	Based on Civ4 Update 1.61
#	This file should reside in  "... /CustomAssets/python/custom" folder.
#
#	Version: $Revision: 1.1.2.2 $ $Date: 2006/07/21 03:44:10 $
#
__author__ = "$Author: simcutie $"
__revision__ = "$Id: DEMO_MoreCityName.py,v 1.1.2.2 2006/07/21 03:44:10 simcutie Exp $"
__version__ = "$Revision: 1.1.2.2 $"
__date__ = "$Date: 2006/07/21 03:44:10 $"

# Random City Name Generator By SimCutie
#
#	Civ4 has XML name list for city name for each civs. But on long game with big map, 
#	the city name list runs out and new city is named as just "City". Not with this mod.
#	This MOD generates random name for the new city.
#	This mod requires SimCutie's Event Framework, but can work without SDK DLL.
#

from CvPythonExtensions import *
import CvUtil

gc = CyGlobalContext()

import PyCivSim

option_debug = False	# If set true, all new city will be named by this mod.

def getRandomItem( aList ) :
	assert len(aList) > 0
	return aList[gc.getGame().getMapRand().get(len(aList), "Random Name")]

def checkCityNameValid( szNewCityName, pTestCity ):
	" check new city name for duplicates or razed city name."
	if PyCivSim.hasExtGC() :
		return PyCivSim.getExtGC().isCityNameValid(unicode(szNewCityName))
	else : 
#		# Ugly *HACK*, but we don't have CvPlayer.isCityNameValid() exposed to Python.
#		oldName = pTestCity.getCityName()
#		pTestCity.setName( szNewCityName, False )
#		newName  = pTestCity.getCityName() 
#		pTestCity.setName( oldName, False )
#		return ( newName == szNewCityName )
		
		for ePlayer in range( gc.getMAX_PLAYERS()):
			pPlayer = gc.getPlayer(ePlayer)
			if not pPlayer.isAlive() :
				continue
			(loopCity, iter) = pPlayer.firstCity(false)
			while(loopCity):
				if ( not loopCity.isNone() 
					and loopCity.getName() == szNewCityName ) :
					return False
				(loopCity, iter) = pPlayer.nextCity(iter, false)
		
		return True
	
#-------------------------------------------------------------------------
# Event handlers
def EventHandlerRegister(evt_mgr, unused = None):
	CvUtil.pyPrint( __name__ + ": Event handler register OK." )
	return { 'cityBuilt+' :		onCityBuilt  }

def onCityBuilt(argsList) :
	'City Built'
	pCity = argsList[0]
	if (( not pCity.getName() or pCity.getNameKey() == "TXT_KEY_CITY")	# unnamed city
		or option_debug ) :
		cityName = getRandomItem(CityNameList)
		while not checkCityNameValid( cityName, pCity ) :
			cityName = getRandomItem(CityNameList)
		
		if option_debug :
			CvUtil.pyPrint( __name__ + ": NEW CITY NAME = " + cityName )
		pCity.setName(unicode(cityName), True)

#	the City Name List is based on "City Names mod for Sevomod v0.3" by Arkaeyn.
CityNameList = (
"Pitjantjatjara", "Arrernte", "Luritja", "Warlpiri", "Anmatyerre", "Alyawarre", "Yolngu", "Noongar", "Eora", "Gurindji", "Diere", "Turuwal", "Wiradjuri", "Gunai", "Taungurong", "Wurundjeri", "Gunivugi", "Burarra", "Awabakal", "Dharug", "Guugu Yimithirr", "Ngunawal", "Yuggera", "Larrakia", "Woolna", "Wadiygini", "Iwaidja", "Gubbi Gubbi", "Wathaurong", "Peramangk", "Bunurong", "Wajuk", "Nyanganyatyara", "Watjarri", "Kuku-Yalanii", "Wakaya", "Antakarinja", "Yankuntjatjara", "Kokatha", "Ngalea", "Nakako", "Mandji", "Ngatatjara", "Pintupi", "Ngarti", "Jaru", "Warumungu", "Warlmanpa", "Kaytej", "Limilngan",
"Addis Ababa", "Aksum", "Gondar", "Assab", "Dese", "Djbout", "Lalibela", "Asmara", "Dire Dawa", "Adama", "Harer", "Debre Tabor", "Bahir Dar", "Adowa", "Ankober", "Debre Berhan", "Amba Mariam", "Adigrat", "Mankorar", "Asosa", "Gambela", "Gode", "Werder", "Geladi", "Dolo", "Maji", "Murle", "Tulu Welel", "Gimbi", "Nejo", "Mek' ele", "K'ebri Dehar", "Gamud", "Degeh Bur", "Imi", "Himora", "Ak'Ordat", "Adis Zemen", "Randa", "Randax", "Agaro", "Shashemene", "Aseb", "Boorama", "Megalo", "Barentu", "Murle", "Yabelo",
"Shkodra", "Durres", "Lezhe", "Kruje", "Vlone", "Prizren", "Ulqin", "Albulena", "Mati", "Prishtina", "Shkup", "Tivari", "Gjirokaster", "Tirana", "Koplik", "Saranda", "Tropoja", "Berat", "Gjakova", "Drenica", "Manasteri", "Fier", "Janina", "Tuzi", "Butrint", "Korca", "Lushnje", "Oher",
"Vienna", "Budapest", "Prague", "Salzburg", "Venice", "Graz", "Belgrade", "Linz", "Innsbruck", "Pilsen", "Sarajevo", "Trieste", "Klagenfurt", "Villach", "Wels", "Sanktpolten", "Dornbirn", "Steyr", "Wienerneustadt", "Feldkirch", "Bregenz", "Klosterneuburg", "Wolfsberg", "Leoben", "Baden", "Traun", "Anderdonau", "Krems", "Leonding", "Amstetten", "Kapfenberg",
"Babylon", "Nineveh", "Ashur", "Ellipi", "Akkad", "Samarra", "Elam", "Mari", "Eulbar", "Shuruppak", "Zariqum", "Sippar", "Izibia", "Carchemish", "Nimrud", "Zamua", "Khorsabad", "Hindana", "Tell Wilaya", "Karana", "Adab", "Telloh", "Nina",
"Ottawa", "Toronto", "Montreal", "Vancouver", "Calgary", "Edmonton", "Quebec", "Winnipeg", "Halifax", "Victoria", "Regina", "Hamilton", "St. John's", "Saskatoon", "Mississauga", "London-Middlesex", "Fredericton", "Windsor", "Laval", "Kitchener", "Charlottetown", "St. Catharines", "Sherbrooke", "Saint John", "Oshawa", "Kelowna", "Sudbury", "Moncton", "Kingston", "Trois-Rivieres", "Cape Breton", "Sault Ste.Marie", "Saguenay", "Brandon", "Red Deer", "Thunder Bay", "Richmond", "Whitehorse", "Yellowknife", "Iqaluit", "Barrie", "Abbotsford", "Guelph", "Chatham", "Peterborough", "Sarnia", "Brampton", "Kamloops", "Brantford", "Nanaimo", "Belleville", "Prince George", "Gander", "Drummondville", "Kawarthas", "Lethbridge", "Prince Albert", "North Bay", "Medicine Hat", "Fort Smith", "Moose Jaw", "Kamloops", "Haviland Bay",
"Carthage", "Utica", "Leptis Magna", "Theveste", "Hippo", "Leptis Minor", "Sabratha", "Rusicade", "Oea", "Hadrumetum", "Cadiz", "Cirta", "Nora", "Rusaddir", "Sulcis", "Saldae", "Carthago Novo", "Malaca", "Gades", "Calaris", "Tingis", "Iol", "Rusguniae", "Thaenae", "Rusuccuru", "al-Kaf", "Zouchis", "Githis", "Tacape", "Zama",
"Cenebum", "Gergovia", "Calleva", "Venta Belgarum", "Isurium", "Duovernum", "Carvetiorum", "Verulamium", "Ratae", "Virioconium", "Moridunum", "Cornium", "Isca", "Durnovaria", "Venta", "Petuaria", "Noviomagus", "Segontium", "Venta Icenorum", "Caesaromagus", "Verulamium", "Lindinis", "Nemetocenna", "Argentomagus", "Burdigala", "Autricum", "Andematunnum", "Parisiorum", "Vesontiensium", "Darioritum", "Narbo Martius", "Tolosa", "Nemausus",
"Mohawk", "Cayuga", "Onondaga", "Seneca", "Oneida", "Tuscarora", "Caughnawaga", "Susquehannock", "Tionontati", "Erie", "Powhaten", "Mingo", "Narragansett", "Nowadaga", "Saratoga", "Gewauga", "Owego", "Dyosyowan", "Yoroonwago", "Awegen", "Cowassalon", "Tueadasso", "Gadoquat", "Canajoharie", "Kanadaseagea", "Osquake", "Neodakheat", "Kawauka", "Skoiyase", "Joneadih", "Ganadoga", "Hostayuntwa", "Ahaouet", "Touenho", "Shawiangto", "Gandasetaigon", "Keinthe", "Oka", "Tyendenaga",
"Jerusalem", "Hevron", "Yericho", "Acre", "Shechem", "Dor", "Hazor", "Bethel", "Shilo", "Dan", "Bethshan", "Megiddo", "Gibeon", "Tekoa", "Ofra", "Be'er Sheva", "Ashdod", "Telaim", "Gibea", "Gedera", "Ezion Geber", "Zoar", "Ramath Gilead", "Kadesh Barnea", "Ashquelon", "Rabath Ammon", "Bosra", "Aza",
"Seoul", "P'yongyang", "Wonsan", "Pusan", "Namp'o", "Cheju", "Hyangsan", "Ulsan", "Inch'on", "Pyongsang", "Taejon", "Paegam", "Manp'o", "Kaesong", "Chonju", "Sariwon", "Suwon", "Haeju", "Taegu", "Chinje", "Tokch'on", "Ch'ongfu", "Taegwon", "Sokch'o", "Hamhung", "Iri", "Huich'on", "Namwon", "Kumgang", "Oijongbu",
"Kisongo", "Kajaido", "Narok", "Arusha", "Maralal", "Kitui", "Voi", "Kapenguria", "Nanyuki", "Kwale", "Kabarnet", "Kilifi", "Homa Bay", "Embu", "Moshi", "Loitoktok", "Ngong", "Magadi", "Olulung'a", "Mau	", "Lorroki", "Kirisia", "Wamba", "Baragoi", "Waso", "Ngorongoro", "Monduli", "Laikipia", "West Pokot", "Baringo", "Taita", "Malambo", "Namanga",
"Tikal", "Palenque", "Copan", "Chichen Itza", "Kalakmul", "Bonampak", "Mayapan", "Edzna", "Altun Ha", "Uaxactun", "Naranja", "Uxmal", "Dos Pilas", "Noj Peten", "Coba", "Yaxuna", "Tulum", "Yaxchilan", "Tazumal", "Kaminaljuyu", "Izamal", "Becl", "Tonintz", "Tazumal", "Xelaj", "Chinkultic", "Lubaant", "Utatl", "Dzibilchaltun", "Uac Cab'nal", "Xunantunich", "Nim Li Punit", "Yo'okop", "Quirigul", "Oxhuitza",
"Amsterdam", "Rotterdam", "Utrecht", "Eindhoven", "Brussels", "The Hague", "Maastricht", "Groningen", "Antwerp", "Heerenveen", "Jakarta", "Curacao", "Haarlem", "Malacca", "Arnhem", "Middelburg", "Delft", "Breda", "Leiden", "Den Helder", "Harlingen", "Enchede", "Tilburg", "Zwolle", "Gouda", "Dordrecht", "Leerdam", "Hilversum", "Roosendaal", "Lauwersoog",
"Ulundi", "Bulaweyo", "Eshowe", "Phongala", "Ethekwini", "Tshwane", "Isandlwana", "Mzizima", "Hlobane", "Umgungundlovu", "Matola", "Gabarone", "Beira", "Tembisa", "Nampula", "Chitungwiza", "Mbabane", "Arusha", "Mbeya", "Huambo", "Molepolole", "Epumalanga", "Ladysmtih", "KwaDukuza", "Esikhawini", "Empangeni", "Nongoma", "Magudu", "Mondlo", "Endumeni", "Mtunzini", "Tongati",
"Byblos", "Sidon", "Tyre", "Aradus", "Beirut", "Tripoli", "Acre", "Safita", "Sarepta", "Akhzib", "Irqanata", "Usanata", "Shiana", "Simyra", "Kition", "Sexi", "Soluntum", "Tharros", "Sulcis", "Carteia", "Motya", "Panormus", "Hadrametum", "Sabrata", "Girba", "Melita", "Pantelaria", "Nora", "Ebusos", "Palma", "Mago", "Lixus",
"Krakow", "Warsaw", "Vilnius", "Lodz", "Katowice", "Riga", "Poznan", "Gdansk", "Legnica", "Plock", "Wroclaw", "Sandomierz", "Lublin", "Gniezno", "Torun", "Opole", "Kolobrzeg", "Olsztyn", "Koszalin", "Szczecin", "Skierniewice", "Piotrkow", "Przemysl", "Radom", "Krosno", "Zamosc", "Czersk", "Kielce", "Czestochowa",
"Lisbon", "Porto", "Faro", "Braga", "Sao Paolo", "Ceuta", "Rio de Janeiro", "Guimar", "Coimbra", "Macau", "Goa", "Beja", "Set", "Leiria", "Aveiro", "Guarda", "Bragan", "Ponta Delgada", "Portalegre", "Nora", "Viseu", "Vila Real", "Viana do Castelo", "Santar", "Funchal", "Dam", "Diu", "Luanda", "Louren Marques", "Bissau", "Praia",
"Edinburgh", "Glasgow", "Stirling", "Falkirk", "Perth", "Glenrothes", "Motherwell", "Hamilton", "Aberdeen", "Inverness", "Livingston", "Dumfries", "Dundee", "Irvine", "Kilmarnock", "Ayr", "Forfar", "Kirkintilloch", "Dumbarton", "Lochgilphead", "Haddington", "Giffnock", "Elgin", "Greenock", "Dalkeith", "Alloa", "Lerwick", "Kirkwall",
"Ur", "Sumer", "Eridu", "Uruk", "Nippur", "Lagash", "Kish", "Larsa", "Umma", "Isin", "Badtibira", "Erech", "Akshak", "Zabalum", "Kissura", "Der", "Kua", "Marad", "Kuara", "Kutha", "Nagsu", "Susa", "Tutub", "Kutallu", "Anshan", "Apisala", "Dabrum",
"Constantinople", "Ankara", "Izmir", "Antalya", "Edirine", "Trabzon", "Bursa", "Samsun", "Izmit", "Edessa", "Adana", "Aleppo", "Konya", "Gaziantep", "Manisa", "Sivas", "Aydin", "Kayseri", "Eskisehir", "Kutahya", "Karama", "Afyon", "Canakkale", "Erzurum", "Bolu", "Diyarbakir", "Malatya", "Erzincan", "Tekirdag", "Kirikkale", "Isparta", "Zonguldak", "Mersin", "Rize", "Kars", "Van", "Antep", "Mardin", "Uskudar", "Iznik",
"Trondheim", "Uppsala", "Oslo", "Stockholm", "Hedeby", "Copenhagen", "Goteborg", "Birka", "Reykjavik", "Bergen", "Ribe", "Viborg", "Eketorp", "Roskilde", "Trondenes", "Aarhus", "Helsingborg", "L'Anse aux Meadows", "Uppla", "Sigtuna", "Lindholm", "Skara", "Visby", "Torg", "Jelling", "Lade", "Helgoity", "Steigen", "Aggersborg", "Paviken", "Slesvik", "Odense", "Brattahlid", "Tunafors", "Bjon", "Jorvik", "Nicopia", "Alesund", "Harstad", "Nebro", "Lejre", "Aldeigjuborg", "Nylo", "Ronneby", "Westness", "Jarlshof", "Holmgo", "Kvivik", "Herjolfsnes", "Lund", "Askrigg", "Sebbersund", "Nyborg", "Lahammer", "Tune",
"Saigon", "Toronto", "Ulundi", "Edinburgh", "Glasgow", "Tirana", "Longcheng", "Tula", "Teotihuacan", "Hanoi", "Manila", "Veii", "Melbourne", "Monaco", "Sydney", "Casablanca", "Bissandugu", "Geneva", "Little Big Horn", "Bangkok", "Luxembourg", "Florence", "Dublin", "Torino", "Bukhara", "Rhapta", "Sarkel", "Atil", "Kells", "Calakmul", "Mesa Verde", "Cahokia", "Cahuachi", "Moche", "Kampala", "Helsinki", "Bern", "Sofia", "Bucharest", "Knossos", "Dakar", "Lagos", "Kinshasa", "Nairobi", "Praetoria", "Djibouti", "Mogadishu", "Zanzibar", "Kathmandu", "Kuala Lumpur", "Singapore", "Cacaxtla", "Alesia", "Ghazna", "Khartoum", "Dar es Salaam", "Napata", "Meroe", "Ugarit",
)

